"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var react_redux_1 = require("react-redux");
var lodash_1 = require("lodash");
var actions_1 = require("../../../../system/actions");
var actions_2 = require("../../actions");
var layouts_1 = require("../../../../ui/layouts");
var hooks_1 = require("../../../../hooks");
var permissions_1 = require("../../permissions");
var PermissionGroupCRUDForm_1 = require("./PermissionGroupCRUDForm");
var PermissionGroupCRUDTable_1 = require("./PermissionGroupCRUDTable");
var core_1 = require("@material-ui/core");
var CRUD = layouts_1.HOCCrud(PermissionGroupCRUDForm_1.PermissionGroupCRUDForm, PermissionGroupCRUDTable_1.PermissionGroupCRUDTable);
var PermissionGroupCRUD = react_1.memo(function (props) {
    var _a = react_1.useState(null), id_current_group = _a[0], setIdCurrentGroup = _a[1];
    var dispatch = react_redux_1.useDispatch();
    var loadData = function () {
        var fetchActivePermissions = function () { return dispatch(actions_2.fetchPermissionsActive({
            callback: function () { return setIdCurrentGroup(null); }
        })); };
        return dispatch(actions_2.fetchPermissionsGroups({ callback: fetchActivePermissions }));
    };
    var updatePermission = function (permission) {
        var callback = function () {
            dispatch(actions_2.fetchPermissionGroup(id_current_group));
            dispatch(actions_1.notificarAction("Se ha actualizado con \u00E9xito el grupo de permisos con el permiso " + permission.codename));
        };
        if (id_current_group) {
            dispatch(actions_2.addPermissionGroup(id_current_group, permission.id, { callback: callback }));
        }
    };
    var lookForFunction = function (list, look_for_field) {
        return lodash_1.pickBy(list, function (permission) {
            return (permission.codename.toString().toLowerCase().includes(look_for_field.toString().toLowerCase()) ||
                (permission.name_plus ? permission.name_plus.toString().toLowerCase().includes(look_for_field.toString().toLowerCase()) : true));
        });
    };
    var onSelectItemDetail = function (item) { return dispatch(actions_2.fetchPermissionGroup(item.id, { callback: function () { return setIdCurrentGroup(item.id); } })); };
    react_1.useEffect(function () {
        loadData();
        return function () {
            dispatch(actions_2.clearPermissionsGroups());
            dispatch(actions_2.clearPermissions());
        };
    }, []);
    var permissions_groups = react_redux_1.useSelector(function (state) { return state.permissions_groups; });
    var permissions = react_redux_1.useSelector(function (state) { return state.permissions; });
    var has_permissions = hooks_1.useHasPermissions(permissions_1.GROUPS_PERMISSIONS_PERMISSIONS);
    var method_pool = {
        fetchObjectMethod: function (id, options) { return dispatch(actions_2.fetchPermissionGroup(id, options)); },
        deleteObjectMethod: function (id, options) { return dispatch(actions_2.deletePermissionGroup(id, options)); },
        createObjectMethod: function (item, options) { return dispatch(actions_2.createPermissionGroup(item, options)); },
        updateObjectMethod: function (id, item, options) { return dispatch(actions_2.updatePermissionGroup(id, item, options)); },
    };
    var selected_group = id_current_group ? permissions_groups[id_current_group] : null;
    if (selected_group) {
        permissions = lodash_1.mapKeys(lodash_1.map(permissions, function (p) {
            // @ts-ignore
            return (__assign(__assign({}, p), { in_group: selected_group.permissions.includes(p.id) }));
        }), 'id');
    }
    return react_1.default.createElement(react_1.Fragment, null,
        react_1.default.createElement(CRUD, { method_pool: method_pool, list: permissions_groups, permissions: has_permissions, onSelectItemDetail: onSelectItemDetail, plural_name: 'Grupos Permisos', singular_name: 'Grupo Permiso', loadData: loadData }),
        selected_group &&
            react_1.default.createElement("div", { className: "row pl-5" },
                react_1.default.createElement("div", { className: "col-12" },
                    react_1.default.createElement(core_1.Typography, { variant: "h6", gutterBottom: true, color: "primary" },
                        "Permisos de: ",
                        selected_group.to_string)),
                react_1.default.createElement(layouts_1.LookingForListFilter, null, function (look_for_field) {
                    var permission_filtered_list = lookForFunction(permissions, look_for_field);
                    return (lodash_1.map(permission_filtered_list, function (p) {
                        return (react_1.default.createElement("div", { key: p.id, className: 'col-12 col-md-6 col-lg-4 col-xl-3' },
                            react_1.default.createElement(core_1.FormControlLabel, { control: react_1.default.createElement(core_1.Checkbox, { key: p.id, 
                                    // @ts-ignore
                                    checked: p.in_group, onChange: function () { return updatePermission(p); }, color: 'primary' }), label: p.to_string })));
                    }));
                })));
});
exports.PermissionGroupCRUD = PermissionGroupCRUD;
