"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var PermissionGroupCRUDTableItem_1 = require("./PermissionGroupCRUDTableItem");
var layouts_1 = require("../../../../ui/layouts");
var lodash_1 = require("lodash");
var lookForFunction = function (list, look_for_text) {
    return lodash_1.pickBy(list, function (permission_group) {
        return (permission_group.name.toString().toLowerCase().includes(look_for_text));
    });
};
function areEqual(prevProps, nextProps) {
    return prevProps.list === nextProps.list;
}
var PermissionGroupCRUDTable = react_1.memo(function (props) {
    var permissions = props.permissions, onSelectItemDetail = props.onSelectItemDetail, onDelete = props.onDelete;
    var data = lodash_1.map(props.list);
    return (react_1.default.createElement(layouts_1.LookingForListFilter, null, function (look_for_field) {
        var group_filtered_list = lookForFunction(data, look_for_field);
        return (react_1.default.createElement("table", { className: 'table table-responsive' },
            react_1.default.createElement("thead", null,
                react_1.default.createElement("tr", null,
                    react_1.default.createElement("th", null, "Nombre"),
                    permissions.change && react_1.default.createElement("th", null, "Editar"),
                    permissions.delete && react_1.default.createElement("th", null, "Eliminar"),
                    permissions.detail && react_1.default.createElement("th", null, "Ver Permisos"))),
            react_1.default.createElement("tbody", null, lodash_1.map(group_filtered_list, function (item) {
                return react_1.default.createElement(PermissionGroupCRUDTableItem_1.PermissionGroupCRUDTableItem, __assign({ onDelete: onDelete, onSelectItemDetail: onSelectItemDetail, key: item.id, item: item }, props));
            }))));
    }));
}, areEqual);
exports.PermissionGroupCRUDTable = PermissionGroupCRUDTable;
