"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var react_redux_1 = require("react-redux");
var core_1 = require("@material-ui/core");
var PermissionTableItem_1 = require("./PermissionTableItem");
var permissions_1 = require("../../permissions");
var system_1 = require("../../../../system");
var layouts_1 = require("../../../../ui/layouts");
var hooks_1 = require("../../../../hooks");
var system_2 = require("../../../../system");
var lodash_1 = require("lodash");
var actions_1 = require("../../actions");
var lookForFunction = function (list, look_for_text) {
    return lodash_1.pickBy(list, function (permission) {
        return (permission.codename.toString().toLowerCase().includes(look_for_text) ||
            permission.name.toString().toLowerCase().includes(look_for_text) ||
            (permission.name_plus ? permission.name_plus.toString().toLowerCase().includes(look_for_text) : false));
    });
};
var PermissionTable = react_1.memo(function (props) {
    var dispatch = react_redux_1.useDispatch();
    var loadData = function () {
        dispatch(actions_1.fetchPermissions());
    };
    var has_permissions = hooks_1.useHasPermissions(permissions_1.PERMISSION_PERMISSIONS);
    var permissions = react_redux_1.useSelector(function (state) { return state.permissions; });
    var onUpdatePermission = function (permission) {
        var callback = function () {
            dispatch(system_2.notificarAction("Se ha actualizado con \u00E9xito el permission " + permission.codename));
        };
        dispatch(actions_1.updatePermission(permission.id, permission, { callback: callback }));
    };
    react_1.useEffect(function () {
        loadData();
        return function () {
            dispatch(actions_1.clearPermissions());
        };
    }, []);
    return (react_1.default.createElement(react_1.Fragment, null,
        react_1.default.createElement(core_1.Typography, { variant: "h5", gutterBottom: true, color: "primary" }, "Lista de Permisos"),
        react_1.default.createElement(layouts_1.LookingForListFilter, null, function (look_for_field) {
            var permissions_filtered_list = lookForFunction(permissions, look_for_field);
            return react_1.default.createElement("table", { className: 'table tabla-maestra table-responsive' },
                react_1.default.createElement("thead", null,
                    react_1.default.createElement("tr", null,
                        react_1.default.createElement("th", null, "Name"),
                        react_1.default.createElement("th", null, "Codename"),
                        has_permissions.change_plus &&
                            react_1.default.createElement(react_1.Fragment, null,
                                react_1.default.createElement("th", null, "Activo"),
                                react_1.default.createElement("th", null, " Nombre")))),
                react_1.default.createElement("tbody", null, lodash_1.map(permissions_filtered_list, function (item) {
                    return react_1.default.createElement(PermissionTableItem_1.PermissionTableItem, { key: item.id, item: item, updatePermission: onUpdatePermission, can_change: has_permissions.change_plus });
                })));
        }),
        react_1.default.createElement(system_1.LoadData, { loadData: loadData })));
});
exports.PermissionTable = PermissionTable;
