"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var react_redux_1 = require("react-redux");
var CountryCreateFromFileTable_1 = require("./CountryCreateFromFileTable");
var lodash_1 = require("lodash");
var hooks_1 = require("../../../../hooks");
var layouts_1 = require("../../../../ui/layouts");
var permissions_1 = require("../../permissions");
var actions_1 = require("../../actions");
var CountryCRUDTable_1 = require("./CountryCRUDTable");
var CountryCRUDForm_1 = require("./CountryCRUDForm");
var CreateFromFileDialog_1 = require("../CreateFromFileDialog");
var CRUD = layouts_1.HOCCrud(CountryCRUDForm_1.CountryCRUDForm, CountryCRUDTable_1.CountryCRUDTable);
var CountryCRUD = react_1.memo(function (props) {
    var dispatch = react_redux_1.useDispatch();
    var _a = react_1.useState(null), countries_file = _a[0], setCountriesFile = _a[1];
    var _b = react_1.useState(false), loading_states = _b[0], setLoadingStates = _b[1];
    var _c = react_1.useState(false), loading_cities = _c[0], setLoadingCities = _c[1];
    var inputFileChanged = function (e) {
        var reader = new FileReader();
        var file = e.target.files[0];
        reader.onload = function (n) {
            // @ts-ignore
            setCountriesFile(JSON.parse(n.target.result));
        };
        reader.readAsText(file);
    };
    var inputFileStatesChanged = function (e) {
        var reader = new FileReader();
        var file = e.target.files[0];
        reader.onload = function (n) {
            // @ts-ignore
            onUploadAllStates(JSON.parse(n.target.result));
        };
        reader.readAsText(file);
    };
    var inputFileCitiesChanged = function (e) {
        var reader = new FileReader();
        var file = e.target.files[0];
        reader.onload = function (n) {
            // @ts-ignore
            onUploadAllCities(JSON.parse(n.target.result));
        };
        reader.readAsText(file);
    };
    var view_link = props.view_link;
    var loadData = function () {
        dispatch(actions_1.fetchCountries());
    };
    var onCreateFromFile = function (country) { return dispatch(actions_1.createCountry(__assign(__assign({}, country), { pk: country.id }), {
        callback: function () {
            loadData();
        }
    })); };
    var onUploadAllCountries = function (coutries) {
        dispatch(actions_1.createMultipleCountries(lodash_1.map(coutries), { callback: function () { return setCountriesFile(null); } }));
    };
    var onUploadAllStates = function (states) {
        setLoadingStates(true);
        dispatch(actions_1.createMultipleStates(lodash_1.map(states), { callback: function () { return setLoadingStates(false); } }));
    };
    var recursiveUploadCities = function (cities) {
        var size = cities.length;
        var times = Math.ceil(size / 300);
        if (times >= 1) {
            var cities_to_upload = cities.slice(0, 300);
            cities = cities.slice(300, size);
            dispatch(actions_1.createMultipleCities(cities_to_upload, { callback: function () { return recursiveUploadCities(cities); } }));
        }
        else {
            setLoadingCities(false);
        }
    };
    var onUploadAllCities = function (cities) {
        setLoadingCities(true);
        recursiveUploadCities(lodash_1.map(cities, function (c) { return ({ id: c.id, name: c.name, state_id: c.state_id }); }));
    };
    var countries = react_redux_1.useSelector(function (state) { return state.countries; });
    var permissions = hooks_1.useHasPermissions(permissions_1.COUNTRIES_PERMISSIONS);
    react_1.useEffect(function () {
        loadData();
        return function () { return dispatch(actions_1.clearCountries()); };
    }, []);
    var method_pool = {
        fetchObjectMethod: function (id, options) { return dispatch(actions_1.fetchCountry(id, options)); },
        deleteObjectMethod: function (id, options) { return dispatch(actions_1.deleteCountry(id, options)); },
        createObjectMethod: function (item, options) { return dispatch(actions_1.createCountry(item, options)); },
        updateObjectMethod: function (id, item, options) { return dispatch(actions_1.updateCountry(id, item, options)); }
    };
    //_.map(data, e => console.log(e));
    var current_countries_ids = react_1.useMemo(function () { return lodash_1.map(countries, function (c) { return c.id; }); }, [countries]);
    return react_1.default.createElement(react_1.Fragment, null,
        countries_file === null && react_1.default.createElement("input", { type: 'file', onChange: inputFileChanged }),
        !loading_states && react_1.default.createElement("input", { type: 'file', onChange: inputFileStatesChanged }),
        !loading_cities && react_1.default.createElement("input", { type: 'file', onChange: inputFileCitiesChanged }),
        permissions.add && react_1.default.createElement(CreateFromFileDialog_1.CreateFromFileDialog, { title: 'Creación Masiva Países', modal_open: countries_file !== null, onCancel: function () { return setCountriesFile(null); } },
            react_1.default.createElement(CountryCreateFromFileTable_1.CountryCreateFromFileTable, { list: lodash_1.pickBy(countries_file, function (c) { return !current_countries_ids.includes(c.id); }), onCreateFromFile: onCreateFromFile, onUploadAllCountries: onUploadAllCountries })),
        react_1.default.createElement(CRUD, { method_pool: method_pool, list: countries, permissions: __assign(__assign({}, permissions), { add: false }), plural_name: 'Paises', singular_name: 'Pa\u00EDs', view_link: view_link, loadData: loadData }));
});
exports.CountryCRUD = CountryCRUD;
