"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var redux_form_1 = require("redux-form");
var forms_1 = require("../../../../ui/forms");
var dialogs_1 = require("../../../../ui/dialogs");
var country_form_validate_1 = __importDefault(require("./country_form_validate"));
var CountryCRUDForm = react_1.memo(function (props) {
    var pristine = props.pristine, submitting = props.submitting, reset = props.reset, initialValues = props.initialValues, onSubmit = props.onSubmit, onCancel = props.onCancel, handleSubmit = props.handleSubmit, modal_open = props.modal_open, singular_name = props.singular_name;
    return (react_1.default.createElement(dialogs_1.FormDialog, { onCancel: onCancel, onSubmit: handleSubmit(onSubmit), reset: reset, initialValues: initialValues, submitting: submitting, modal_open: modal_open, pristine: pristine, element_type: singular_name },
        react_1.default.createElement("div", { className: "col-12" },
            react_1.default.createElement("div", { className: "row" },
                initialValues && react_1.default.createElement(forms_1.MyTextFieldSimple, { disabled: true, type: 'number', className: "col-3 col-md-2", label: 'Id', name: 'id' }),
                !initialValues && react_1.default.createElement(forms_1.MyTextFieldSimple, { type: 'number', className: "col-3 col-md-2", label: 'Id', name: 'pk' }),
                react_1.default.createElement(forms_1.MyTextFieldSimple, { className: "col-7 col-md-10", label: 'Nombre', name: 'name' }))),
        react_1.default.createElement("div", { className: "col-12" },
            react_1.default.createElement("div", { className: "row" },
                react_1.default.createElement(forms_1.MyTextFieldSimple, { className: "col-12 col-md-6", label: 'Moneda', name: 'currency' }),
                react_1.default.createElement(forms_1.MyTextFieldSimple, { className: "col-12 col-md-6", label: 'Indicativo Telefono', name: 'phone_code' }))),
        react_1.default.createElement("div", { className: "col-12" },
            react_1.default.createElement("div", { className: "row" },
                react_1.default.createElement(forms_1.MyTextFieldSimple, { className: "col-12 col-md-6", label: 'Iso 3', name: 'iso3' }),
                react_1.default.createElement(forms_1.MyTextFieldSimple, { className: "col-12 col-md-6", label: 'Iso 2', name: 'iso2' })))));
});
exports.CountryCRUDForm = CountryCRUDForm;
exports.CountryCRUDForm = CountryCRUDForm = redux_form_1.reduxForm({
    form: "countryCRUDForm",
    validate: country_form_validate_1.default,
    enableReinitialize: true
    // @ts-ignore
})(CountryCRUDForm);
