"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@material-ui/core");
var react_1 = __importStar(require("react"));
var react_table_1 = __importDefault(require("react-table"));
var icons_1 = require("../../../../ui/icons");
var lodash_1 = require("lodash");
var CountryCreateFromFileTable = react_1.memo(function (props) {
    var list = props.list, onCreateFromFile = props.onCreateFromFile, onUploadAllCountries = props.onUploadAllCountries;
    var data = list;
    return (react_1.default.createElement(react_1.Fragment, null,
        react_1.default.createElement(core_1.Button, { color: "primary", variant: "contained", onClick: function () { return onUploadAllCountries(list); } }, "Subir"),
        react_1.default.createElement(react_table_1.default, { data: lodash_1.map(data), noDataText: "No hay elementos para mostrar del archivo", columns: [
                {
                    Header: "General",
                    columns: [
                        {
                            Header: "Id",
                            accessor: 'id',
                            maxWidth: 80,
                            minWidth: 80
                        },
                        {
                            Header: "Nombres",
                            accessor: 'name',
                            maxWidth: 300,
                            minWidth: 300,
                            filterable: true,
                            filterMethod: function (filter, row) { return row[filter.id].toUpperCase().includes(filter.value.toUpperCase()); }
                        },
                        {
                            Header: "Cod. Tel.",
                            accessor: 'phone_code',
                            maxWidth: 70,
                            minWidth: 70
                        },
                        {
                            Header: "Moneda",
                            accessor: 'currency',
                            maxWidth: 70,
                            minWidth: 70
                        },
                        {
                            Header: "Iso 3",
                            accessor: 'iso3',
                            maxWidth: 70,
                            minWidth: 70
                        },
                        {
                            Header: "Iso 2",
                            accessor: 'iso2',
                            maxWidth: 70,
                            minWidth: 70
                        },
                        {
                            Header: "Crear",
                            maxWidth: 50,
                            Cell: function (row) { return react_1.default.createElement(icons_1.CustomIconTable, { icon: 'check', onClick: function () { return onCreateFromFile(row.original); } }); }
                        },
                    ]
                }
            ], defaultPageSize: 10, className: "-striped -highlight" })));
});
exports.CountryCreateFromFileTable = CountryCreateFromFileTable;
