"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var react_redux_1 = require("react-redux");
var layouts_1 = require("../../../../ui/layouts");
var hooks_1 = require("../../../../hooks");
var actions_1 = require("../../actions");
var permissions_1 = require("../../permissions");
var states_1 = require("../states");
var CountryDetail = react_1.memo(function (props) {
    var state_view_link = props.state_view_link;
    var id = props.match.params.id;
    var dispatch = react_redux_1.useDispatch();
    var country = react_redux_1.useSelector(function (state) { return state.countries[id]; });
    var permission = hooks_1.useHasPermissions(permissions_1.COUNTRIES_PERMISSIONS);
    var loadData = function () { return dispatch(actions_1.fetchCountry(id)); };
    react_1.useEffect(function () {
        loadData();
        return function () { return dispatch(actions_1.clearCountries()); };
    }, []);
    if (!country) {
        return react_1.default.createElement("div", null, "Cargando...");
    }
    return react_1.default.createElement(layouts_1.DetailLayout, { permissions: permission, singular_name: 'Pa\u00EDs', title: "Detalle de " + country.to_string, loadData: loadData, info_items: [
            {
                id: 1,
                label: 'Nombre',
                text_value: country.name,
                className: 'col-12 col-sm-5 col-lg-4'
            },
            {
                id: 2,
                label: 'Indicativo Teléfono',
                text_value: country.phone_code,
                className: 'col-12 col-sm-3 col-lg-2'
            },
            {
                id: 3,
                label: 'Moneda',
                text_value: country.currency,
                className: 'col-12 col-sm-3 col-lg-2'
            },
            {
                id: 4,
                label: 'Iso 2',
                text_value: country.iso2,
                className: 'col-6 col-sm-3 col-lg-2'
            },
            {
                id: 5,
                label: 'Iso 3',
                text_value: country.iso3,
                className: 'col-6 col-sm-3 col-lg-2'
            },
        ] },
        react_1.default.createElement(states_1.StateCRUD, { country: country, loadData: loadData, view_link: state_view_link }));
});
exports.CountryDetail = CountryDetail;
