"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var dialogs_1 = require("../../../../ui/dialogs");
var icons_1 = require("../../../../ui/icons");
var react_router_dom_1 = require("react-router-dom");
var lodash_1 = require("lodash");
var react_table_1 = __importDefault(require("react-table"));
function areEqual(prevProps, nextProps) {
    return prevProps.list === nextProps.list;
}
var CountryStateCRUDTable = react_1.memo(function (props) {
    var data = props.list;
    var singular_name = props.singular_name, onDelete = props.onDelete, onSelectItemEdit = props.onSelectItemEdit, permissions = props.permissions, onSelectForDelete = props.onSelectForDelete, view_link = props.view_link;
    return (react_1.default.createElement("div", null,
        react_1.default.createElement(react_table_1.default, { data: lodash_1.map(data), noDataText: "No hay elementos para mostrar tipo " + singular_name, columns: [
                {
                    Header: "General",
                    columns: [
                        {
                            Header: "Id",
                            accessor: 'id',
                            maxWidth: 80,
                            minWidth: 80
                        },
                        {
                            Header: "Nombres",
                            accessor: 'to_string',
                            maxWidth: 300,
                            minWidth: 300,
                            filterable: true,
                            filterMethod: function (filter, row) { return row[filter.id].toUpperCase().includes(filter.value.toUpperCase()); }
                        },
                        {
                            Header: "Cod. Departamento.",
                            accessor: 'state_code',
                            maxWidth: 100,
                            minWidth: 100
                        },
                    ]
                },
                {
                    Header: "Opciones",
                    columns: [
                        {
                            Header: "Elimi.",
                            show: permissions.delete,
                            maxWidth: 50,
                            Cell: function (row) { return react_1.default.createElement(dialogs_1.DeleteDialog, { onSelectForDelete: onSelectForDelete, onDelete: function () {
                                    onDelete(row.original);
                                }, element_name: row.original.to_string, element_type: singular_name }); }
                        },
                        {
                            Header: "Editar",
                            show: permissions.change,
                            maxWidth: 50,
                            Cell: function (row) { return react_1.default.createElement(icons_1.CustomIconTable, { icon: 'edit', onClick: function () { return onSelectItemEdit(row.original); } }); }
                        },
                        {
                            Header: "Ver",
                            show: permissions.detail,
                            maxWidth: 50,
                            Cell: function (row) { return react_1.default.createElement(react_router_dom_1.Link, { to: "" + view_link + row.original.id },
                                react_1.default.createElement(icons_1.CustomIconTable, { icon: 'eye' })); }
                        }
                    ]
                }
            ], defaultPageSize: 10, className: "-striped -highlight" })));
}, areEqual);
exports.CountryStateCRUDTable = CountryStateCRUDTable;
