"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var react_redux_1 = require("react-redux");
var layouts_1 = require("../../../../ui/layouts");
var hooks_1 = require("../../../../hooks");
var actions_1 = require("../../actions");
var permissions_1 = require("../../permissions");
var __1 = require("..");
var StateDetail = react_1.memo(function (props) {
    var id = props.match.params.id;
    var country_view_link = props.country_view_link;
    var dispatch = react_redux_1.useDispatch();
    var state = react_redux_1.useSelector(function (state) { return state.countries_states[id]; });
    var permission = hooks_1.useHasPermissions(permissions_1.STATES_PERMISSIONS);
    var loadData = function () { return dispatch(actions_1.fetchState(id)); };
    react_1.useEffect(function () {
        loadData();
        return function () { return dispatch(actions_1.clearStates()); };
    }, []);
    if (!state) {
        return react_1.default.createElement("div", null, "Cargando...");
    }
    return react_1.default.createElement(layouts_1.DetailLayout, { permissions: permission, singular_name: 'Pa\u00EDs', title: "Detalle de " + state.to_string, loadData: loadData, info_items: [
            {
                id: 1,
                label: 'País',
                text_value: state.country_name,
                className: 'col-12 col-sm-5 col-lg-4',
                link: "" + country_view_link + state.country
            },
            {
                id: 2,
                label: 'Nombre',
                text_value: state.name,
                className: 'col-12 col-sm-5 col-lg-4'
            },
            {
                id: 3,
                label: 'Código Estado',
                text_value: state.state_code,
                className: 'col-12 col-sm-3 col-lg-2'
            }
        ] },
        react_1.default.createElement(__1.CityCRUD, { state: state, loadData: loadData }));
});
exports.StateDetail = StateDetail;
