"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var functions_1 = require("../../../system/functions");
var current_url_api = 'authentication';
exports.clear_authentication_errors = function () {
    return function (dispatch) {
        dispatch({ type: "LOGIN_FAILED", data: null });
    };
};
exports.logout = function (options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var callback_error = function (error) {
            if (error.status === 403 || error.status === 401) {
                dispatch({ type: "AUTHENTICATION_ERROR", data: error.response.data });
            }
            else {
                dispatch({ type: "LOGIN_FAILED", data: error.response.data });
            }
        };
        var dispatches = function () {
            dispatch({ type: 'LOGOUT_SUCCESSFUL' });
        };
        var options = __assign(__assign({ dispatches: dispatches,
            callback_error: callback_error }, options_action), { dispatch_method: dispatch });
        return functions_1.fetchListGet(current_url_api + "/logout", options);
    };
};
exports.loadUser = function (options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var callback_error = function (error) {
            if (error.response.status >= 400 && error.response.status < 500) {
                dispatch({ type: "AUTHENTICATION_ERROR", data: error.response.data });
            }
        };
        var dispatches = function (response) {
            var _a = response.data.username, username = _a === void 0 ? '' : _a;
            if (username === '') {
                dispatch({ type: 'NOT_USER_LOADED', user: response.data });
            }
            else {
                dispatch({ type: 'USER_LOADED', user: response.data });
            }
        };
        var options = __assign(__assign({ dispatches: dispatches,
            callback_error: callback_error }, options_action), { dispatch_method: dispatch });
        // @ts-ignore
        return functions_1.fetchListGet(current_url_api + "/load_user", options);
    };
};
exports.login = function (username, password, options_action) {
    if (options_action === void 0) { options_action = {}; }
    return function (dispatch) {
        var callback_error = function (error) {
            if (error.response.status === 403 || error.response.status === 401) {
                dispatch({ type: "AUTHENTICATION_ERROR", data: error.response.data });
            }
            else {
                dispatch({ type: "LOGIN_FAILED", data: error.response.data });
            }
        };
        var dispatches = function (response) {
            if (response.status === 200) {
                dispatch({ type: 'LOGIN_SUCCESSFUL', data: response.data });
            }
        };
        var options = __assign(__assign({ dispatches: dispatches,
            callback_error: callback_error }, options_action), { dispatch_method: dispatch });
        var params = new URLSearchParams();
        params.append('username', username);
        params.append('password', password);
        // @ts-ignore
        return functions_1.fetchListPostURLParameters(current_url_api, 'login', params, options);
    };
};
