"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var react_redux_1 = require("react-redux");
var forms_1 = require("../../../ui/forms");
var UserFormBase = react_1.memo(function (props) {
    var onLoadCities = props.onLoadCities, onFetchCity = props.onFetchCity, clearCities = props.clearCities, fullScreen = props.fullScreen;
    var dispatch = react_redux_1.useDispatch();
    return (react_1.default.createElement(react_1.Fragment, null,
        react_1.default.createElement(forms_1.MyTextFieldSimple, { className: fullScreen ? 'col-12 col-md-4 col-lg-3' : 'col-12 col-md-6', label: 'Nombre de Usuario', name: 'username', case: 'L' }),
        react_1.default.createElement(forms_1.MyTextFieldSimple, { className: fullScreen ? 'col-12 col-md-4 col-lg-4' : 'col-12 col-md-6', label: 'Nombre a Mostrar', name: 'alias', case: 'U' }),
        react_1.default.createElement(forms_1.MyTextFieldSimple, { className: "col-12", label: 'Correo Electr\u00F3nico', name: 'email', case: 'U' }),
        react_1.default.createElement(forms_1.MyTextFieldSimple, { className: "col-12 col-md-6", label: 'Nombres', name: 'first_name', case: 'U' }),
        react_1.default.createElement(forms_1.MyTextFieldSimple, { className: "col-12 col-md-6", label: 'Apellidos', name: 'last_name', case: 'U' }),
        react_1.default.createElement("div", { className: "col-12" },
            react_1.default.createElement("div", { className: "row" },
                react_1.default.createElement(forms_1.MyDateTimePickerField, { dropUp: true, className: fullScreen ? 'col-12 col-md-6 col-lg-3' : 'col-12', label: 'Fecha de Nacimiento', name: 'date_of_birth', show_time_until_now: true }),
                react_1.default.createElement(forms_1.MyCombobox, { className: fullScreen ? 'col-12 col-md-6 col-lg-3' : 'col-12', label_space_xs: 4, label: 'G\u00E9nero', name: "gender", data: [
                        { id: "F", nombre: "Femenino" },
                        { id: "M", nombre: "Masculino" },
                    ], textField: 'nombre', valueField: 'id', placeholder: 'G\u00E9nero...', filter: 'contains' }),
                react_1.default.createElement(forms_1.MySelectAsync, { cleanMethod: function () { return dispatch(clearCities()); }, className: fullScreen ? 'col-12 col-md-6 col-lg-6' : 'col-12', label_space_xs: 3, 
                    //cacheOptions
                    onLoadOptions: function (text, callback) { return dispatch(onLoadCities(text, { callback: callback })); }, inicialValueLoader: function (text, callback) { return dispatch(onFetchCity(text, { callback: callback })); }, label: 'Ciudad Residencia', name: 'city' })))));
});
exports.UserFormBase = UserFormBase;
