"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var react_redux_1 = require("react-redux");
var actions_1 = require("../../actions");
var countries_1 = require("../../../countries");
var hooks_1 = require("../../../../hooks");
var actions_2 = require("../../../../system/actions");
var permissions_1 = require("../../permissions");
var index_1 = require("../index");
var styles_1 = require("@material-ui/core/styles");
var Typography_1 = __importDefault(require("@material-ui/core/Typography"));
var useStyles = styles_1.makeStyles(function (theme) { return ({
    error: {
        color: "" + theme.palette.error.main
    },
    card: {
        minWidth: 275,
        marginTop: '10px'
    },
    bullet: {
        display: 'inline-block',
        margin: '0 2px',
        transform: 'scale(0.8)',
    },
    title: {
        fontSize: 14,
    },
    pos: {
        marginBottom: 12,
    },
}); });
var ManageAccount = react_1.memo(function (props) {
    var permissions = hooks_1.useHasPermissions(permissions_1.USERS_PERMISSIONS);
    var dispatch = react_redux_1.useDispatch();
    var user_id = props.user_id, is_mine = props.is_mine, _a = props.children, children = _a === void 0 ? null : _a;
    var change_password_user = permissions.change_password_user, change_pin_user = permissions.change_pin_user, change_qr_user = permissions.change_qr_user, change_profile_image_user = permissions.change_profile_image_user, change_profile_user = permissions.change_profile_user, change_password_other_user = permissions.change_password_other_user, change_pin_other_user = permissions.change_pin_other_user, change_qr_other_user = permissions.change_qr_other_user, change_profile_image_other_user = permissions.change_profile_image_other_user, change_profile_other_user = permissions.change_profile_other_user;
    var show_change_password = !is_mine ? change_password_other_user : change_password_user;
    var show_change_profile = !is_mine ? change_profile_other_user : change_profile_user;
    var show_change_image_profile = !is_mine ? change_profile_image_other_user : change_profile_image_user;
    var show_change_pin = !is_mine ? change_pin_other_user : change_pin_user;
    var show_change_qr = !is_mine ? change_qr_other_user : change_qr_user;
    var user = react_redux_1.useSelector(function (state) { return state.users; })[user_id];
    var classes = useStyles();
    react_1.useEffect(function () {
        dispatch(actions_1.fetchUser(user_id));
        return function () { return dispatch(actions_1.clearUsers()); };
    }, [user_id]);
    var onProfileImageUpload = function (e) {
        var file = e.target.files[0];
        if (file) {
            var formData = new FormData();
            formData.append('profile_image', file);
            dispatch(actions_1.uploadProfileImageUser(user.id, formData, {
                callback: function () {
                    dispatch(actions_2.notificarAction("Se ha la imagen del perfil correctamente"));
                    dispatch(actions_1.fetchUser(user_id));
                }
            }));
        }
    };
    if (!user) {
        return react_1.default.createElement("div", null, "Cargando...");
    }
    return (react_1.default.createElement("div", { className: "row" },
        is_mine && react_1.default.createElement("div", { className: "col-12" },
            react_1.default.createElement(Typography_1.default, { variant: "h3", gutterBottom: true, color: "primary" }, user.to_string)),
        show_change_password && react_1.default.createElement("div", { className: "col-12 col-md-4 col-lg-3" },
            react_1.default.createElement(index_1.ChangePasswordForm, { classes: classes, user: user, is_mine: is_mine, changePasswordOtherUser: actions_1.changePasswordOtherUser, changePasswordUser: actions_1.changePasswordUser })),
        show_change_pin && react_1.default.createElement("div", { className: "col-12 col-md-4 col-lg-3" },
            react_1.default.createElement(index_1.ChangePinForm, { classes: classes, user: user, is_mine: is_mine, changeSecurityPinOtherUser: actions_1.changeSecurityPinOtherUser, changeSecurityPinUser: actions_1.changeSecurityPinUser })),
        show_change_qr && react_1.default.createElement("div", { className: "col-12 col-md-4 col-lg-3 text-center" },
            react_1.default.createElement(index_1.SecurityQR, { user: user, classes: classes, generateSecurityQrUser: actions_1.generateSecurityQrUser, showSecurityQrUser: actions_1.showSecurityQrUser })),
        show_change_image_profile && react_1.default.createElement("div", { className: "col-12 col-md-4 col-lg-3 text-center" },
            react_1.default.createElement(index_1.ProfileImage, { user: user, classes: classes, onProfileImageUpload: onProfileImageUpload })),
        show_change_profile && react_1.default.createElement("div", { className: "col-12" },
            react_1.default.createElement(index_1.UserProfileForm, { onLoadCities: countries_1.fetchCitiesByName, onFetchCity: countries_1.fetchCity, clearCities: countries_1.clearCities, classes: classes, initialValues: user, updateUser: function (v) { return actions_1.updateUser(user_id, v, {
                    callback: function () {
                        dispatch(actions_1.fetchUser(user_id));
                        if (is_mine) {
                            actions_1.loadUser();
                        }
                    }
                }); } })),
        children && react_1.default.createElement(react_1.Fragment, null, children)));
});
exports.ManageAccount = ManageAccount;
