"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var redux_form_1 = require("redux-form");
var change_pin_form_validate_1 = __importDefault(require("./change_pin_form_validate"));
var Button_1 = __importDefault(require("@material-ui/core/Button"));
var Typography_1 = __importDefault(require("@material-ui/core/Typography"));
var Card_1 = __importDefault(require("@material-ui/core/Card"));
var CardContent_1 = __importDefault(require("@material-ui/core/CardContent"));
var UserFormBase_1 = require("../UserFormBase");
var react_redux_1 = require("react-redux");
var UserProfileForm = react_1.memo(function (props) {
    var updateUser = props.updateUser, pristine = props.pristine, submitting = props.submitting, reset = props.reset, handleSubmit = props.handleSubmit, error = props.error, classes = props.classes, onLoadCities = props.onLoadCities, onFetchCity = props.onFetchCity, clearCities = props.clearCities;
    var dispatch = react_redux_1.useDispatch();
    return (react_1.default.createElement(Card_1.default, { className: classes.card },
        react_1.default.createElement(CardContent_1.default, null,
            react_1.default.createElement("form", { onSubmit: handleSubmit(function (v) { return dispatch(updateUser(v)); }) },
                react_1.default.createElement(Typography_1.default, { variant: "h5", gutterBottom: true, color: "primary" }, "Perfil Usuario"),
                react_1.default.createElement(UserFormBase_1.UserFormBase, { fullScreen: false, onLoadCities: onLoadCities, onFetchCity: onFetchCity, clearCities: clearCities }),
                react_1.default.createElement("div", { className: 'mt-3' },
                    react_1.default.createElement(Typography_1.default, { variant: "caption", gutterBottom: true, className: classes.error }, error && react_1.default.createElement("strong", null, error))),
                react_1.default.createElement("div", { className: "col-12" },
                    react_1.default.createElement(Button_1.default, { color: "primary", type: 'submit', variant: "contained", className: 'ml-3', disabled: submitting || pristine }, "Cambiar"),
                    react_1.default.createElement(Button_1.default, { color: "secondary", variant: "contained", className: 'ml-3', disabled: submitting || pristine, onClick: reset }, "Limpiar"))))));
});
exports.UserProfileForm = UserProfileForm;
exports.UserProfileForm = UserProfileForm = redux_form_1.reduxForm({
    form: "userProfileForm",
    validate: change_pin_form_validate_1.default,
    enableReinitialize: true
    // @ts-ignore
})(UserProfileForm);
