"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var react_redux_1 = require("react-redux");
var actions_1 = require("../../actions");
var UserCRUDTable_1 = require("./UserCRUDTable");
var UserCRUDForm_1 = require("./UserCRUDForm");
var hooks_1 = require("../../../../hooks");
var permissions_1 = require("../../permissions");
var layouts_1 = require("../../../../ui/layouts");
var CRUD = layouts_1.HOCCrud(UserCRUDForm_1.UserCRUDForm, UserCRUDTable_1.UserCRUDTable);
var UserCRUD = react_1.memo(function (props) {
    var view_link = props.view_link, _a = props.form_additional_fields, form_additional_fields = _a === void 0 ? null : _a, _b = props.onFormMount, onFormMount = _b === void 0 ? null : _b, _c = props.onFormUnmount, onFormUnmount = _c === void 0 ? null : _c;
    var dispatch = react_redux_1.useDispatch();
    var users = react_redux_1.useSelector(function (state) { return state.users; });
    var loadData = function () { return dispatch(actions_1.fetchUsers()); };
    var permissions = hooks_1.useHasPermissions(permissions_1.USERS_PERMISSIONS);
    react_1.useEffect(function () {
        loadData();
        return function () { return dispatch(actions_1.clearUsers()); };
    }, []);
    var method_pool = {
        fetchObjectMethod: function (id, options) { return dispatch(actions_1.fetchUser(id, options)); },
        deleteObjectMethod: function (id, options) { return dispatch(actions_1.deleteUser(id, options)); },
        createObjectMethod: function (item, options) { return dispatch(actions_1.createUser(item, options)); },
        updateObjectMethod: function (id, item, options) { return dispatch(actions_1.updateUser(id, item, options)); },
        selectForDeleteObjectMethod: function (id, options) { return dispatch(actions_1.fetchUser(id, options)); },
    };
    return react_1.default.createElement(CRUD, { method_pool: method_pool, list: users, permissions: permissions, plural_name: 'Usuarios', singular_name: 'Usuario', view_link: view_link, onFormMount: onFormMount, onFormUnmount: onFormUnmount, form_additional_fields: form_additional_fields, loadData: loadData });
});
exports.UserCRUD = UserCRUD;
