"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var redux_form_1 = require("redux-form");
var react_redux_1 = require("react-redux");
var UserFormBase_1 = require("../UserFormBase");
var user_form_validate_1 = require("./user_form_validate");
var user_async_validate_1 = require("./user_async_validate");
var forms_1 = require("../../../../ui/forms");
var dialogs_1 = require("../../../../ui/dialogs");
var countries_1 = require("../../../countries");
var selector = redux_form_1.formValueSelector('userCRUDForm');
var UserCRUDForm = react_1.memo(function (props) {
    var pristine = props.pristine, submitting = props.submitting, reset = props.reset, initialValues = props.initialValues, onSubmit = props.onSubmit, onCancel = props.onCancel, handleSubmit = props.handleSubmit, modal_open = props.modal_open, singular_name = props.singular_name, form_additional_fields = props.form_additional_fields, onFormMount = props.onFormMount, onFormUnmount = props.onFormUnmount;
    var form_values = react_redux_1.useSelector(function (state) { return selector(state, 'multi_sessions', ''); });
    var _a = form_values.multi_sessions, multi_sessions = _a === void 0 ? false : _a;
    react_1.useEffect(function () {
        onFormMount ? onFormMount() : null;
        return function () { return onFormUnmount ? onFormUnmount() : null; };
    }, []);
    return (react_1.default.createElement(dialogs_1.FormDialog, { onCancel: onCancel, onSubmit: handleSubmit(onSubmit), reset: reset, initialValues: initialValues, submitting: submitting, modal_open: modal_open, pristine: pristine, element_type: singular_name, fullScreen: true },
        react_1.default.createElement(UserFormBase_1.UserFormBase, { clearCities: countries_1.clearCities, onFetchCity: countries_1.fetchCity, onLoadCities: countries_1.fetchCitiesByName, initialValues: initialValues, fullScreen: true }),
        form_additional_fields && form_additional_fields,
        !initialValues && react_1.default.createElement("div", { className: 'col-12' },
            react_1.default.createElement("div", { className: "row" },
                react_1.default.createElement(forms_1.MyTextFieldSimple, { type: 'password', className: "col-12 col-md-6", label: 'Contrase\u00F1a', name: 'password' }),
                react_1.default.createElement(forms_1.MyTextFieldSimple, { type: 'password', className: "col-12 col-md-6", label: 'Comprobaci\u00F3n de contrase\u00F1a', name: 'password2' }))),
        initialValues && react_1.default.createElement("div", { className: 'col-12 col-md-6' },
            react_1.default.createElement("div", { className: "row" },
                react_1.default.createElement(forms_1.MyCheckboxSimple, { className: 'col-8 col-md-6', name: 'multi_sessions', label: 'Session Multiple' }),
                multi_sessions && react_1.default.createElement(forms_1.MyTextFieldSimple, { type: 'number', className: "col-4 col-md-6", label: 'Cantidad sessiones multiples', name: 'multi_sessions_qty' }))),
        react_1.default.createElement("div", { style: { minHeight: '300px' } })));
});
exports.UserCRUDForm = UserCRUDForm;
exports.UserCRUDForm = UserCRUDForm = redux_form_1.reduxForm({
    form: "userCRUDForm",
    // @ts-ignore
    validate: user_form_validate_1.user_form_validate,
    asyncValidate: user_async_validate_1.userAsyncValidate,
    asyncBlurFields: ['username'],
    enableReinitialize: true
    // @ts-ignore
})(UserCRUDForm);
