"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var initialState = {
    token: localStorage.getItem("token"),
    my_permissions: localStorage.getItem("my_permissions"),
    isAuthenticated: false,
    isLoading: true,
    user: null,
    errors: {},
};
var authenticationReducer = function (state, action) {
    if (state === void 0) { state = initialState; }
    switch (action.type) {
        case 'USER_LOADING':
            return __assign(__assign({}, state), { isLoading: true });
        case 'USER_LOADED':
            return __assign(__assign({}, state), { isAuthenticated: true, isLoading: false, user: action.user });
        case 'NOT_USER_LOADED':
            return __assign(__assign({}, state), { isAuthenticated: false, isLoading: false, user: null });
        case 'LOGIN_SUCCESSFUL':
            localStorage.setItem("token", action.data.token);
            // @ts-ignore
            localStorage.setItem("my_permissions", []);
            return __assign(__assign(__assign({}, state), action.data), { isAuthenticated: true, isLoading: false, errors: null });
        case 'AUTHENTICATION_ERROR':
        case 'LOGIN_FAILED':
        case 'LOGOUT_SUCCESSFUL':
            localStorage.removeItem("token");
            localStorage.removeItem("my_permissions");
            return __assign(__assign({}, state), { errors: action.data, token: '', user: {}, isAuthenticated: false, isLoading: false, my_account: {} });
        default:
            return state;
    }
};
exports.authenticationReducer = authenticationReducer;
