"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var types_1 = require("../actions/types");
var initial_values = {
    loading: false,
    messages: {},
    error: '',
    title: '',
    index: 0
};
var loadingReducer = function (state, action) {
    var _a, _b;
    if (state === void 0) { state = initial_values; }
    var new_index = state.index;
    switch (action.type) {
        case types_1.LOADING_TYPES.loading:
            new_index = state.index > 0 ? state.index + 1 : 1;
            return {
                index: new_index,
                loading: new_index > 0,
                messages: new_index > 0 ? (action.message ? __assign(__assign({}, state.messages), (_a = {}, _a[action.message] = action.message, _a)) : state.messages) : {},
                error: false,
                title: action.title ? action.title : 'Procesando...'
            };
        case types_1.LOADING_TYPES.stop:
            new_index = state.index > 0 ? state.index - 1 : 0;
            return {
                index: new_index,
                loading: new_index > 0,
                messages: new_index <= 0 ? [] : state.messages,
                error: false,
                title: new_index > 0 ? state.title : ''
            };
        case types_1.LOADING_TYPES.error:
            return {
                index: 0,
                loading: true,
                messages: action.message ? __assign(__assign({}, state.messages), (_b = {}, _b[action.message] = action.message, _b)) : ['Ocurrió un Error'],
                error: true,
                title: "Error " + action.title
            };
        case types_1.LOADING_TYPES.reset:
            return initial_values;
        default:
            return state;
    }
};
exports.loadingReducer = loadingReducer;
