"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var types_1 = require("../actions/types");
var initial_values = {
    open_menu: false,
    close_submenu: false,
    open_submenu: false,
    qty_open_submenu: 0,
};
var menuReducer = function (state, action) {
    if (state === void 0) { state = initial_values; }
    switch (action.type) {
        case types_1.MENU_TYPES.open:
            return {
                open_menu: true,
                submenu_abiertos: state.qty_open_submenu
            };
        case types_1.MENU_TYPES.close:
            return {
                open_menu: false,
                submenu_abiertos: state.qty_open_submenu
            };
        case types_1.MENU_TYPES.close_submenu:
            return {
                open_menu: state.open_menu,
                submenu_abiertos: state.qty_open_submenu - 1
            };
        case types_1.MENU_TYPES.open_submenu:
            return {
                open_menu: state.open_menu,
                submenu_abiertos: state.qty_open_submenu + 1
            };
        case types_1.MENU_TYPES.reset:
            return initial_values;
        default:
            return state;
    }
};
exports.menuReducer = menuReducer;
