"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var index_1 = require("./index");
var hooks_1 = require("../../hooks");
var lodash_1 = require("lodash");
var MenuItem = react_1.memo(function (props) {
    var _a = props.menu_item, text = _a.text, icon = _a.icon, link = _a.link, _b = _a.type, type = _b === void 0 ? 'normal' : _b, _c = _a.permissions, permissions = _c === void 0 ? null : _c, _d = _a.collapse_menu_items, collapse_menu_items = _d === void 0 ? [] : _d;
    switch (type) {
        case "collapse":
            var permissions_results = lodash_1.map(collapse_menu_items, function (e) { return hooks_1.useHasPermissions(e.permissions); });
            var has_sub_menu = permissions_results.filter(function (r) { return r === true; }).length > 0;
            if (has_sub_menu) {
                return react_1.default.createElement(index_1.DrawerMenuListCollapse, { icon: icon, text: text },
                    react_1.default.createElement(react_1.Fragment, null, 
                    // @ts-ignore
                    collapse_menu_items.map(function (i) {
                        var has_permission = hooks_1.useHasPermissions(i.permissions);
                        if (has_permission) {
                            return react_1.default.createElement(index_1.DrawerListItem, { key: i.text, size: 'lg', link: i.link, text: i.text, icon: i.icon, type: 'nested' });
                        }
                        else {
                            return null;
                        }
                    })));
            }
            else {
                return null;
            }
        case "normal":
            var has_permission = hooks_1.useHasPermissions(permissions);
            if (has_permission) {
                return react_1.default.createElement(index_1.DrawerListItem, { type: 'main', size: 'lg', link: link, text: text, icon: icon });
            }
            else {
                return null;
            }
        default:
            return null;
    }
});
var Menu = react_1.memo(function (props) {
    var menu_items = props.menu_items;
    return react_1.default.createElement(react_1.Fragment, null, menu_items.map(function (e) { return react_1.default.createElement(MenuItem, { menu_item: e, key: e.text }); }));
});
exports.Menu = Menu;
