"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var components_1 = require("../../system/components");
var react_redux_1 = require("react-redux");
var core_1 = require("@material-ui/core");
var actions_1 = require("../../system/actions");
var lodash_1 = __importDefault(require("lodash"));
var HOCCrud = function (CreateForm, Table) {
    var CRUD = function (props) {
        var dispatch = react_redux_1.useDispatch();
        var method_pool = props.method_pool, view_link = props.view_link, _a = props.method_pool.restoreObjectMethod, restoreObjectMethod = _a === void 0 ? null : _a, _b = props.posDeleteMethod, posDeleteMethod = _b === void 0 ? null : _b, _c = props.posCreateMethod, posCreateMethod = _c === void 0 ? null : _c, _d = props.posUpdateMethod, posUpdateMethod = _d === void 0 ? null : _d, _e = props.posSummitMethod, posSummitMethod = _e === void 0 ? null : _e, singular_name = props.singular_name, list = props.list, plural_name = props.plural_name, permissions = props.permissions, _f = props.show_title, show_title = _f === void 0 ? true : _f, _g = props.loadData, loadData = _g === void 0 ? null : _g;
        var checkboxTable = react_1.useRef(null);
        var _h = react_1.useState(null), selected_item = _h[0], setSelectedItem = _h[1];
        var _j = react_1.useState(false), modal_open = _j[0], setModalOpen = _j[1];
        var _k = react_1.useState([]), selected_rows = _k[0], setSelectedRows = _k[1];
        var _l = react_1.useState(false), are_select_all_rows = _l[0], setSelectAllRows = _l[1];
        var isRowTableSelected = function (key) { return selected_rows.includes(key); };
        var toggleRowSelection = function (key, shift, row) {
            var new_selection = __spreadArrays(selected_rows);
            var keyIndex = new_selection.indexOf(key);
            if (keyIndex >= 0) {
                new_selection = __spreadArrays(new_selection.slice(0, keyIndex), new_selection.slice(keyIndex + 1));
            }
            else {
                new_selection = __spreadArrays(new_selection, [key]);
            }
            setSelectedRows(new_selection);
            var wrappedInstance = checkboxTable.current.getWrappedInstance();
            var currentRecords = wrappedInstance.getResolvedState().sortedData;
            var selecciono_todos = lodash_1.default.size(currentRecords) === new_selection.length;
            setSelectAllRows(selecciono_todos);
        };
        var toggleAllRows = function () {
            var new_selection = [];
            if (!are_select_all_rows) {
                var wrappedInstance = checkboxTable.current.getWrappedInstance();
                var currentRecords = wrappedInstance.getResolvedState().sortedData;
                new_selection = currentRecords.map(function (item) { return item._original.id; });
            }
            setSelectAllRows(!are_select_all_rows);
            setSelectedRows(new_selection);
        };
        var rowFn = function (state, rowInfo, column, instance) {
            return {
                onClick: function (e, handleOriginal) {
                    if (handleOriginal) {
                        handleOriginal();
                    }
                },
                style: {
                    background: rowInfo &&
                        selected_rows.includes(rowInfo.original.id) &&
                        "lightblue"
                }
            };
        };
        var getTrGroupProps = function (state, rowInfo) {
            if (rowInfo !== undefined) {
                return {
                    key: rowInfo ? rowInfo.original.id : null
                };
            }
        };
        var onDelete = function (item) {
            if (method_pool.deleteObjectMethod === null) {
                console.log('No se ha asignado ningún método para DELETE');
            }
            else {
                var callback = function () {
                    var to_string = item.to_string;
                    var options = {
                        title: 'Eliminación Exitosa',
                        time: 5
                    };
                    dispatch(actions_1.notificarAction("Se ha eliminado con \u00E9xito " + singular_name.toLowerCase() + " " + to_string, options));
                    setModalOpen(false);
                    setSelectedItem(null);
                    if (posDeleteMethod) {
                        posDeleteMethod(item);
                    }
                };
                return method_pool.deleteObjectMethod(item.id, { callback: callback });
            }
        };
        var setSelectItem = function (selected_item) { return setSelectedItem(selected_item); };
        var onSelectForDelete = function () {
            if (method_pool.selectForDeleteObjectMethod) {
                console.log('lo hizo');
            }
        };
        var onSelectItemEdit = function (item) {
            var callback = function (response) {
                setSelectedItem(response);
                setModalOpen(true);
            };
            if (method_pool.fetchObjectMethod === null) {
                console.log('No se ha asignado ningún método para FETCH OBJECT');
            }
            else {
                return method_pool.fetchObjectMethod(item.id, { callback: callback });
            }
        };
        var onSubmit = function (item, uno, dos, cerrar_modal) {
            if (uno === void 0) { uno = null; }
            if (dos === void 0) { dos = null; }
            if (cerrar_modal === void 0) { cerrar_modal = true; }
            var es_form_data = item instanceof FormData;
            var form_data_id = es_form_data ? item.get('id') : null;
            var callback = function (response) {
                var to_string = response.to_string;
                var options = {
                    title: item.id ? 'Actualizacion Exitosa' : 'Creación Exitosa',
                    time: 5
                };
                dispatch(actions_1.notificarAction("Se ha " + (item.id ? 'actualizado' : 'creado') + " con \u00E9xito " + singular_name.toLowerCase() + " " + to_string, options));
                setModalOpen(!cerrar_modal);
                setSelectedItem(cerrar_modal ? null : response);
                if (item.id && posUpdateMethod) {
                    posUpdateMethod(response);
                }
                if (!item.id && posCreateMethod) {
                    posCreateMethod(response);
                }
                if (posSummitMethod) {
                    posSummitMethod(response);
                }
            };
            if (item.id || (es_form_data && form_data_id)) {
                if (method_pool.updateObjectMethod === null) {
                    console.log('No se ha asignado ningún método para UPDATE');
                }
                else {
                    if (es_form_data) {
                        return method_pool.updateObjectMethod(form_data_id, item, { callback: callback });
                    }
                    return method_pool.updateObjectMethod(item.id, item, { callback: callback });
                }
            }
            else {
                if (method_pool.createObjectMethod === null) {
                    console.log('No se ha asignado ningún método para CREATE');
                }
                else {
                    return method_pool.createObjectMethod(item, { callback: callback });
                }
            }
        };
        return (react_1.default.createElement(components_1.ValidatePermissions, { can_see: permissions.list, name: plural_name },
            show_title && react_1.default.createElement(core_1.Typography, { variant: "h5", gutterBottom: true, color: "primary" }, plural_name),
            permissions.add && CreateForm && react_1.default.createElement(core_1.Button, { color: 'primary', className: 'ml-3', onClick: function () {
                    setModalOpen(true);
                    setSelectedItem(null);
                } }, "Nuevo"),
            selected_rows.length > 0 && react_1.default.createElement(components_1.ExcelDownload, { data: lodash_1.default.map(lodash_1.default.pickBy(list, function (l) { return selected_rows.includes(l.id); })), name: plural_name ? plural_name : 'documento', file_name: plural_name ? plural_name : 'documento' }),
            modal_open && react_1.default.createElement(CreateForm, __assign({}, props, { initialValues: selected_item ? list[selected_item.id] : null, modal_open: modal_open, onCancel: function () {
                    setSelectedItem(null);
                    setModalOpen(false);
                }, onSubmit: onSubmit, setSelectItem: setSelectItem })),
            Table && react_1.default.createElement("div", null,
                react_1.default.createElement(Table, __assign({}, props, { getTrGroupProps: getTrGroupProps, rowFn: rowFn, isSelected: isRowTableSelected, toggleSelection: toggleRowSelection, toggleAll: toggleAllRows, selection: selected_rows, selectAll: are_select_all_rows, checkboxTable: checkboxTable, updateItem: onSubmit, onDelete: onDelete, onSelectForDelete: onSelectForDelete, onSelectItemEdit: onSelectItemEdit, view_link: view_link }))),
            loadData && react_1.default.createElement(components_1.LoadData, { loadData: loadData })));
    };
    return CRUD;
};
exports.HOCCrud = HOCCrud;
