import React from "react";
import { IconName } from "@fortawesome/fontawesome-common-types";
import { ICommonPermisions } from "../../../interfaces";
interface IInfoItem {
    id: number;
    label: string;
    text_value: string;
    className: string;
    link?: string;
    title?: string;
    icon_value?: IconName;
    items?: IInfoItem[];
}
interface IDetailLayout {
    title: string;
    singular_name: string;
    permissions: ICommonPermisions;
    info_items?: IInfoItem[];
    info_list_items_link?: IInfoItem[];
    children: React.ReactNode;
    loadData?: () => any;
}
declare const DetailLayout: (props: IDetailLayout) => JSX.Element;
export { DetailLayout };
